library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity bram_socket is
generic (
    -- SHIFT     : integer := 14;
	-- ADDR		: std_logic_vector;
    C_BASEADDR   : std_logic_vector(0 to 31) := X"FFFFFFFF";
    C_MASK       : std_logic_vector(0 to 31) := X"00800000"
    );
    port (
     Rst : in std_logic;
     Clk : in std_logic;
     EN : in std_logic;
	 WEN : in std_logic_vector(0 to 3);
     Addr : in std_logic_vector(0 to 31);
     Din : out std_logic_vector(0 to 31);
     Dout : in std_logic_vector(0 to 31);
	 
     BRAM_Rst : out std_logic;
     BRAM_Clk : out std_logic;
     BRAM_EN : out std_logic;
	 BRAM_WEN : out std_logic_vector(0 to 3);
     BRAM_Addr : out std_logic_vector(0 to 31);
     BRAM_Din : in std_logic_vector(0 to 31);
     BRAM_Dout : out std_logic_vector(0 to 31)
    );
  end bram_socket;
  
architecture imp of bram_socket is

  component pselect_mask is
    generic (
      C_AW   : integer                   := 32;
      C_BAR  : std_logic_vector(0 to 31) := X"00000000";
      C_MASK : std_logic_vector(0 to 31) := X"00800000");
    port (
      A     : in  std_logic_vector(0 to 31);
      CS    : out std_logic;
      Valid : in  std_logic);
  end component;
  
--signal address : std_logic_vector(0 to 15) := X"FFF7";
-- signal mask : std_logic_vector(0 to SHIFT-1) := (others => '0');
  signal One : std_logic;
  signal fsm_select : std_logic;

begin

Din <= BRAM_Din;

BRAM_Clk <= Clk;
BRAM_Rst <= Rst;
BRAM_EN <= EN;
BRAM_WEN <= WEN;
-- BRAM_Addr <= Addr;
BRAM_Dout <= Dout;
	 
--address <= address + 1;
		   
  READ_DATA:process (clk, rst)
  begin
    if Clk'event and Clk = '1' then
      if Rst = '1' then
         BRAM_Addr <= (others => '0');
      -- elsif EN = '1' then
	     -- BRAM_EN <= '1';
			-- BRAM_Addr <= Addr;
	  -- else BRAM_EN <= '0';
	  -- BRAM_Addr <= (others => '0');
	  else BRAM_Addr <= Addr;
      end if;
    end if;
  end process READ_DATA;

   One <= EN;
  pselect_mask_fsm : pselect_mask
    generic map (
      C_AW   => Addr'length,
      C_BAR  => C_BASEADDR,
      C_MASK => C_MASK)
    port map (
      A     => Addr,
      CS    => fsm_select,
      Valid => One);
	  
end architecture imp;
