library ieee;
use ieee.std_logic_1164.ALL;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;
use xps_reclogen_v1_00_a.drp_fsm;
use xps_reclogen_v1_00_a.ReCloGen;


entity dcm_drp is
   port ( Rst       : in std_logic;
	 CLK        : in std_logic;
	 Mul_Div    : in std_logic_vector(15 downto 0);
	 go	    : in std_logic;
	 CLKFX_OUT  : out std_logic
	 );
end dcm_drp;

architecture BEHAVIORAL of dcm_drp is

signal Data_Address : std_logic_vector (6 downto 0); 
signal Data_Enable : std_logic; 
signal Data_In : std_logic_vector (15 downto 0); 
signal Data_Write_Enable : std_logic; 
signal DataOut : std_logic_vector (15 downto 0); 
signal Ready : std_logic; 
signal Locked : std_logic;
signal Rst_out : std_logic;

begin

  DCM_ins : entity xps_reclogen_v1_00_a.ReCloGen
   port map(
	  CLKIN_IN => CLK,
          DADDR_IN => Data_Address,
          DCLK_IN => CLK,
          DEN_IN => Data_Enable,
          DI_IN => Data_In,
          DWE_IN => Data_Write_Enable,
          RST_IN => Rst_out,
          CLKFX_OUT => CLKFX_OUT,
          CLKIN_IBUFG_OUT => open,
          CLK0_OUT => open,
          DO_OUT => DataOut,
	  DRDY_OUT => Ready,
          LOCKED_OUT => Locked);
  FSM_ins : entity xps_reclogen_v1_00_a.drp_fsm
   port map( 	 
	 Mul_Div => Mul_Div,
	 Rst_in => Rst,
	 go => go,
	 CLKIN_IN => CLK,
         Rst_out => Rst_out,
	 DADDR_IN => Data_Address,
         DEN_IN => Data_Enable,
         DI_IN => Data_In,
         DWE_IN => Data_Write_Enable,
         DO_OUT => DataOut,
	 DRDY_OUT => Ready,
         LOCKED_OUT => Locked
	 );

end architecture BEHAVIORAL;
			 
